#
#  Return the title from the result.txt file 
# parse a string like 32#pathfilename#title
#
proc gettitle { s } {
	set index1str [ string first # "$s" ]
	set strtmp [string range $s [ expr $index1str  + 1] [ string length $s ] ]
	set index2str [ string first # "$strtmp" ]
	set result [string range $strtmp [ expr  $index2str + 1] [ string length $strtmp ] ]
	return $result
}
#
#  Return the pathfilename from the result.txt file 
# parse a string like 32#pathfilename#title
#
proc geturl { s } {
	set index1str [ string first # "$s" ]
	set strtmp [string range $s [ expr $index1str  + 1] [ string length $s ] ]
	set index2str [ string first # "$strtmp" ]
	set result [string range $strtmp 0  [ expr  $index2str - 1]  ]
	return $result
}

#
# Reading the indexing file of the indexed ASCII database ...
# the array indexing is filled
#
proc loadindexingfile { filename } {
global indexing
set f [open $filename r ]
while { ![eof $f] } {
	set string2eval [ gets $f ]
	if { $string2eval == "" } break
	regsub { } $string2eval ") " string2eval
	set string2eval "set indexing($string2eval"
	eval "$string2eval"
	}
puts " loadindexing finish "
}

#
# Load the association number file title
#
proc loadlistefile { filename } {
	global listfile
	set listfile {}
	lappend listfile "ERREUR "
	
	puts " loadlistfile start $filename "
	
	set f [open $filename r ]
	set nbfile [ gets $f ]
	regsub {\[} $nbfile "set  " nbfile
	regsub {\]} $nbfile " " nbfile
	regsub "\:" $nbfile " " nbfile
	eval $nbfile
	
	puts "$nbfile "
	
	for { set i 0 } { $i < $files } { incr i } {
	#	regsub {[0-9]+.*} "[gets $f]" "" result
		lappend listfile [gets $f]
		}
	close $f
	puts "finish ..."
}

proc sorttwoelement { a b }  {
	set fa [lindex $a 0]
	set fb [lindex $b 0]
	if { $fa > $fb } { return 0 } else { return 1 }
}


#
# The main proc to search word 
# sock is the handle of the sock to the web browser
# listname is the lit of name to search 
#
proc search { sock listname } {
#
# The variable of the html form
#
global form
global indexing
global listfile
set listresult {}
#
# Pour tous les mots entrez par l'utilisateur
#
puts "listname $listname "
foreach arg [split $listname ] {

   if {[string length $arg ] < 2 } {
	continue
	}
   # On lit la base d'indexation
   #
   set f [open "result.txt" r ]
   set twoletter   [ string range $arg 0 1 ]
#
# Aucun entree dans l'index de la base
#
   if {![ info exist indexing($twoletter) ] }  {
		continue
	}
   #
   # On se position au bon endroit dans le fichier
   #
   if {[ string length $twoletter ] == 0 } {
		continue
		}
   seek $f $indexing($twoletter)
   while { ![eof $f] } {
   	 set wordline [ gets $f ]
   	 if { $twoletter !=  [ string range $wordline 0 1 ] } break
   	 if { [ string first $arg $wordline] != -1 } {
	#
	# On met dans un tableau les entrees de la base d'indexation
	#
   	 	regsub "=>"  "$wordline" "\) \{ \{" wordline
   	 	regsub -all ":" "$wordline" "\} \{" wordline
   	 	regsub -all "," "$wordline" " " wordline
   	 	set wordline "set tabword\($wordline\} \}" 
   	 	eval $wordline
   		}
	   }
    close $f
   }

#
# If nothing found, tabword not an array 
#
 if {![array exists tabword]} {
	puts $sock " Nothing founded .... "
	return
	}
 foreach  i [array names tabword] {
	puts " word : $i "
   	foreach a $tabword($i) {
		set indexurl [lindex $a 0]
   		if {  [ info exist arrayresult($indexurl) ] }  {
   			set arrayresult($indexurl) \
				"[ expr \
					[lindex $arrayresult($indexurl) 0] + [lindex $a 1] \
				]  \"[lindex $arrayresult($indexurl) 1 ] $i\" "
   		} else  { 
			set arrayresult([lindex $a 0])  \
				"[lindex $a 1] $i"}
   		}
   	}
   foreach i [ array names arrayresult ] {
   lappend listresult "$arrayresult($i) $i"
   }

#
# Listresult word score
# exemple : {5 total 241} {4  totalement 228} 
# 5 ponteration ( score  ) 	: lindex 0
# total word 			: lindex 1
# 241 numero du document	: lindex 2
#
set listresult [ lsort  -command sorttwoelement   $listresult  ]
puts "$listresult"
foreach i $listresult {
	set nbdoc [ lindex $i 2]
	set leword [ lindex $i 1]
	set thescore [ lindex $i 0]

	#set the_title "[ lrange [ lindex $listfile $nbdoc ] 1 end ]"
	set the_title [gettitle [ lindex $listfile $nbdoc ] ]
	set url [geturl [ lindex $listfile $nbdoc ] ]
	
	puts $sock "<li><A HREF=\"$url\"> $the_title </a>\
			<br>$leword nbhit $thescore"
	puts $sock "<br>$url"
	}
}

proc searchcgi { sock } {
global form
loadindexingfile ./indexing.txt
loadlistefile ./result.txt
#loadlistefile ./listfilewithtitle.txt
  puts $sock ""
  puts $sock "<html>"
  puts $sock "<body>"
  puts $sock "<ul>"
  search $sock $form(name)
  puts $sock "</ul>"
  puts $sock "</body>"
  puts $sock "</html>"
}


#
# Add information for the top.tcl
#

set formulaire(searchcgi) {<form action="searchcgi.cgi" method="get" target="mainFrame"> Search : <input name="name" size="40"> <imput type=submit name="search"> </form>}

