# Simple HTML display library by Stephen Uhler (stephen.uhler@sun.com)
############################################
# mapping of html tags to text tag properties
# properties beginning with "T" map directly to text tags

proc HMtest_parse {command tag slash text_after_tag} {
global titlehtml

 set text [ string trim [ string tolower $command ] ]
	if { $text=="title" } {
#		puts stderr "$text_after_tag"
		regsub -all "\n" $text_after_tag {} text_after_tag		
		set titlehtml $titlehtml$text_after_tag
		}
}

proc HMparse_html {html {cmd HMtest_parse}} {
	regsub -all \{ $html {\&ob;} html
	regsub -all \} $html {\&cb;} html
	set w " \t\r\n"	;# white space
	proc HMcl x {return "\[$x\]"}
	set exp <(/?)([HMcl ^$w>]+)[HMcl $w]*([HMcl ^>]*)>
	set sub "\}\n$cmd {\\2} {\\1} {\\3} \{"
	regsub -all $exp $html $sub html
	eval "$cmd hmstart {} {} \{ $html \}"
}


proc glob-r {{dir .}} {

set res {} 
foreach i [lsort [glob -nocomplain $dir/* ]] {
	 if {[file type $i]=="directory"} { 
	eval lappend res [glob-r $i]
	 } else { 
	if ([ regexp {[a-z\:\\\/.]+html} $i toto ]) {
		lappend res $i
		}
	 }
    } 
return $res
} 

#
#
#
proc sitemap { sock } {
global titlehtml 

set nbfile 0

puts $sock "<html><head><title> Site Map  </title><head><h1> Site Map </h1> "
flush $sock

set listfile [ glob-r .]
foreach file $listfile {
	incr nbfile 
	puts stderr "processing $file **** "
	
	#
	# Delete the 2 caracteres of the path should be ./
	#
	set filename [ string range $file 2 [string length $file ] ]
	set filewithtitle($filename) $filename 
	}

set nbfile 0
foreach file $listfile {

	incr nbfile 
#
# Find the html title, title by default is the filename
#
	set titlehtml ""
	set fp [ open $file r]
	catch {HMparse_html [ read $fp ] }
	close $fp
	if {$titlehtml == "" } {
		set filename $file
		}
	puts $sock "<a href=\"$file\">$titlehtml</a><br>"
	flush $sock
	}

flush $sock
}

# Add information for the top.tcl
#

#set formulaire(sitemap) {<form action="sitemap.cgi" method="get" target="mainFrame"> <input type=submit value="site map" name="sitemap"> </form> }


